/* Lschen von Dateien :-)
** aN 970606
*/

#include <io.h>
#include <stdio.h>
#include <direct.h>
#include <windows.h>
#include <shlobj.h>
#include <shellapi.h>

#include "mydel.h"

int SendToRecycleBin(char *filename)
{
	SHFILEOPSTRUCT SHF;
	int l;

	memset(&SHF, 0, sizeof(SHFILEOPSTRUCT));
	l = strlen(filename);
	filename[l+1] = 0;

	SHF.hwnd = NULL;
	SHF.wFunc = FO_DELETE;
	SHF.pFrom = filename;
	SHF.fFlags = FOF_SILENT	| FOF_ALLOWUNDO | FOF_NOCONFIRMATION | FOF_FILESONLY | FOF_NOERRORUI;

	return SHFileOperation(&SHF);
}


int main(int argc, char *argv[])
{
  int i, ec, ready;
  char drive[3], dir[150], name[150], ext[50];
  char path[84], fname[97];
  char full_path[256];
  char *ffn;
  long sum_deleted = 0;
  HANDLE hFindFile;
  LPWIN32_FIND_DATA p_ffblk;

  p_ffblk = (LPWIN32_FIND_DATA) malloc(sizeof(WIN32_FIND_DATA));

  printf("MyDel by Alex\n(c) %s %s\n", __DATE__, __TIME__);

  if (argc >= 2)
  {
    i = 1;
    while(i<argc)
    {
      fnsplit(argv[i],drive,dir,name,ext);
      strcpy(path,drive);
      strcat(path,dir);

      SetCurrentDirectory(path);
	  sprintf(fname, "%s%s", name, ext);

      hFindFile = FindFirstFile(fname, p_ffblk);

      ready = (hFindFile == INVALID_HANDLE_VALUE);

      while (!ready)
      {
		if (strcmp(p_ffblk->cFileName, ".") == 0)				// das eigene Verzeichnis
		{
			ready = ! FindNextFile(hFindFile, p_ffblk);			// weitersuchen
			continue;											// nicht lschen
		}
		if (strcmp(p_ffblk->cFileName, "..") == 0)				// das bergeordnete Verzeichn
		{
			ready = ! FindNextFile(hFindFile, p_ffblk);			// weitersuchen
			continue;											// nicht lschen
		}
		strcpy(fname,path);
		strcat(fname,p_ffblk->cFileName);
		GetFullPathName(fname, 256, full_path, &ffn);

		// if ((ec=unlink(fname)) == 0)
		if ((ec=SendToRecycleBin(full_path)) == 0)
		{
		  sum_deleted += p_ffblk->nFileSizeLow;
		  printf("Datei %s (%ld Bytes) wurde gelscht!\n", full_path, p_ffblk->nFileSizeLow);
		}
		else
		{
		  printf("Datei %s konnte nicht gelscht werden! (%d)\n", full_path, ec);
		}
		ready = ! FindNextFile(hFindFile, p_ffblk);
      }
      i++;
    }
  }

  printf("\nEs wurden %ld Bytes gelscht!\n", sum_deleted);

  return 0;
}
