/* Zerlegen von Dateinamen in seine Komponenten
*/

#include <stdio.h>
#include <string.h>

#include "mydel.h"

int fnsplit(char *filename, char *drive, char *path, char *name, char *ext)
{
  int i;
  char *p_fn;

  while (*filename == ' ')
    ++filename;
  p_fn = filename;


  /* drive versorgen */
  if (*(p_fn+1) == ':')
  {
    *drive++ = *p_fn++;
    *drive++ = *p_fn++;
    *drive = 0;
    filename += 2;
  }
  else
  {
    *drive = 0;
  }

  /* ext versorgen */
  i = strlen(p_fn);
  while ((filename[i] != '.') && (i>0)) --i;
  if ((i != 0) && (filename[i+1] != '\\'))
  {
    p_fn = &filename[i];
    while (*p_fn) *ext++ = *p_fn++;
    *ext = 0;
  }
  else
  {
    i = 0;
    ext[0] = 0;
  }

  /* name versorgen */
  if (i == 0)
  {
    i = strlen(filename);
  }
  else
  {
    i--;
  }

  while ((filename[i] != '\\') && (i>0)) i--;
  p_fn = &filename[i];
  if (*p_fn=='\\') p_fn++;

  while ((*p_fn != 0) && *p_fn != '.') *name++ = *p_fn++;
  *name = 0;

  /* path versorgen */

  if(filename[i] == '\\')
    path[++i] = 0;
  else
    path[i] = 0;

  while (i)
  {
    path[i-1] = filename[i-1];
    i--;
  }

  return 0;
}

